package njn;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class ArticlePanel extends BorderedPanel
{
    Config cfg;
    NewsManager news;

    Dimension ma_size;

    Button b_follow,
               b_reply,
               b_save,
               b_decode,
               b_last,
               b_next;
    Label heading;
    Panel header,
                  buttons;
    TextArea msg_window;
    Graphics g;
    String author,
           subject;

    int left;

    // ------------------------------------------------------- constructor
    public ArticlePanel( Config conf, NewsManager n_data ) {
        cfg = conf;
        news = n_data;

        buildInterface();
        addListeners();
        clear();
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------------
    public void setHeading( String article_sender, String article_subject ) {
        author = article_sender;
        subject = article_subject;
        heading.setText("  " +  subject + "  [" + author + "]");
        heading.validate();
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------------
    public void clear( ) {
        setHeading("No article selected", "");
        msg_window.setText("");
    } // -----------------------------------------------------------------

    
    // -------------------------------------------------------------------
    public void displayArticle( String file_name ) {
        FileReader article_file;
        BufferedReader article;
        String s;
        StringBuffer whole_text;

        whole_text = new StringBuffer("");
        try {
            article_file = new FileReader( file_name );
            article = new BufferedReader( article_file );
            do {
                s = getLine( article );
                if ( s != null )
                    whole_text.append( s );
                whole_text.append("\n");
            } while ( s != null );
            
            try {
                article_file.close();
            } catch( IOException IOe ) {;}
        } catch( FileNotFoundException FNFe ) {;}

        msg_window.setText( whole_text.toString() );
        msg_window.setCaretPosition( 0 );
        
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------------
    private String getLine( BufferedReader input ) {
        String s;
        try {
            s = input.readLine();
        } catch( IOException any ) {
            s = null;
        }
        return s;
    } // -----------------------------------------------------------------


    private void addListeners( ) {
    } // -----------------------------------------------------------------


    // ---------------------------------------------------- buildInterface
    private void buildInterface( ) {
        Panel b;

        this.setBackground( cfg.main_background );

        b_next = new Button(">");
        b_last = new Button("<");
        heading = new Label();
        heading.setAlignment( Label.LEFT );
        heading.setFont( cfg.subject_font );

//        b_next.setActionCommand("Read the next message in this newsgroup");
//        b_last.setActionCommand("Read the previous message in this newsgroup");

//        header = new BorderedPanel( BorderedPanel.RAISED );
        header = new Panel();
        header.setLayout( new GridLayout( 1, 1 ));
        header.add( heading );

//        buttons = new BorderedPanel( BorderedPanel.RAISED );
        buttons = new Panel();
        buttons.setLayout( new MatrixLayout( 3, 5 ));
        b = new Panel( new GridLayout( 1, 2 ));
        b.setFont( new Font("Monospaced", Font.BOLD, 14 ));
        b.add( b_last );
        b.add( b_next );
        buttons.add( b, new MatrixConstraints( true, 1, 1, -4, -4 ));
        
        msg_window = new TextArea();
        msg_window.setBackground( cfg.text_background );
        msg_window.setFont( cfg.article_font );
        msg_window.setEditable( false );

        this.setLayout( new MatrixLayout( 3, 5 ) );
        this.add( header, new MatrixConstraints( true, 1, 1, -55, 26 ));
        this.add( buttons, new MatrixConstraints( true, -54, 1, 52, 26 ));

        this.add( msg_window, new MatrixConstraints( MatrixConstraints.PIXELS,
                                                     2, 28, -5, -31       ));

    } // -----------------------------------------------------------------

} // =======================[ End of ArticlePanel ]=======================

