package njn;
import java.awt.*;

public class BorderedPanel extends Panel
{
    public static final int RECESSED = 0;
    public static final int RAISED = 1;
    public static final int BEVELLED = 2;
    public static final int FLAT = 3;

    private int mode;

    // ------------------------------------------------------ constructors
    public BorderedPanel( ) {
        mode = RECESSED;
    }

    public BorderedPanel( int style ) {
        mode = style;
    } // -----------------------------------------------------------------
    

    // ------------------------------------------------ paint (overridden)
    public void paint( Graphics g ) {
        if (( mode == RECESSED ) || ( mode == FLAT ) || ( mode == BEVELLED ))
            g.setColor( SystemColor.controlShadow );
        else
            g.setColor( SystemColor.controlHighlight );
        g.drawLine( 0, 0, getSize().width - 1, 0 );
        g.drawLine( 0, 0, 0, getSize().height - 1 );
        if (( mode == RECESSED ) || ( mode == BEVELLED ))
            g.setColor( SystemColor.controlHighlight );
        else
            g.setColor( SystemColor.controlShadow );
        g.drawLine( getSize().width - 1, 1, getSize().width - 1, getSize().height - 1 );
        g.drawLine( 1, getSize().height - 1, getSize().width - 1, getSize().height - 1 );
        super.paint( g );
    } // -----------------------------------------------------------------

/*
    // ---------------------------------------------- getSize (overridden)
    public Dimension getSize( ) {
        Dimension size = super.getSize();
        size.width -= 2;
        size.height -= 2;
        return ( size );
    } // -----------------------------------------------------------------
*/
} // ======================[ End of BorderedPanel ]=======================
