package njn;

/**
 *  Represents a newsgroup in the group list.  This class was deliberately
 *  made as small as possible, since we could be instantiating tens of 
 *  thousands of these objects...
 *
 *  Note: when a newsgroup is opened, a NewsGroup object is also created.
 *  
 ****/
public class GroupIndexEntry extends Object
{
    public String name,
           read_list;
    public int total_articles,
               new_articles;
    public boolean is_open;


    // ------------------------------------------------------ constructors
    public GroupIndexEntry( String group_name ) {
        name = group_name;
        is_open = false;
    }

    public GroupIndexEntry( String group_name, String old_articles ) {
        name = group_name;
        read_list = old_articles;
        is_open = false;
    } // -----------------------------------------------------------------

} // ====================[ End of GroupIndexEntry ]=======================

