package njn;

import java.util.*;

/**
 *  Represents an open and active newsgroup.
 *
 ****/
public class NewsGroup extends GroupIndexEntry
{
//    public String name;
//    public int number_articles,
//               number_unread;

            /** 
             *  This is a kludge I'm using until I can get the Article
             *  class into place.
             ****/
    public String article_file;

                            /**
                             *  The name of the group cache file on disk.
                             ****/
    public String cache_file;

                            /**
                             *  The cache of all articles in this group.  
                             *  A Vector of ArticleIndexEntry objects, 
                             *  which can be written to disk & retrieved
                             *  as needed.
                             *****/
    public Vector articles;
    NntpConnection nntp;
    String summary;

    // ------------------------------------------------------- constructor
      /**
       *  @param group_name   The name of the newsgroup.
       *  @param n_sock An NntpConnection object.
       *
       ****/
    public NewsGroup( String group_name, NntpConnection n_sock ) {
        super( group_name );
        nntp = n_sock;
        total_articles = 0;
//      total_articles += openCache();
        total_articles += countNew();
    } // -----------------------------------------------------------------


    // --------------------------------------------------------- openCache
      /*
       *  Search for a cache file associated with this group (will be
       *  named after the group in some reproducible way): open it if it 
       *  exists, create it if it does not.  Set the cache_file variable 
       *  to point to this file.
       *
	   *  return: The number of cached articles.
       *
       *  Not yet implemented.
       *
       */
    private int openCache( ) {
        int old = 0;

        // articles = (Vector)load file article_cache...
        // old = articles.size()

        return ( old );
    } // -----------------------------------------------------------------


    // ---------------------------------------------------------- countNew
      /*
       *  Determine total # articles (0 if not online)
       *  Have to check if online or not, & separate "open group"
       *  from "retrieve overview"...
       *
       */
    private int countNew( ) {
        StringTokenizer tok;
        String err, 
               count;
        int counted = 0;

        if ( nntp.connected ) {
            summary = nntp.getGroup( name );
            tok = new StringTokenizer( summary );
            err = tok.nextToken();            // error code - check this!
            count = tok.nextToken();
            try {
                counted = Integer.parseInt( count );
            } catch( NumberFormatException NFe ) {;}
        }

        return ( counted );
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------- open
      /** 
	   *  Mostly stub code right now.  Should eventually open the article
	   *  cache, and (if online) determine the correct new article range 
	   *  from the newsrc file.
	   *
	   ****/
	public boolean open( ) {
        boolean online;

        if ( nntp.connected ) {
            articles = new Vector();
            online = true;
        }
        else 
            online = false;

        return ( online );
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------------
	  /**
	   *  Download and display list of new articles.
	   *
	   ****/
    public String refresh() {
        String message;
        Vector new_headers;
        int i;

                // first I should get the desired range from newsrc!
                //    (having already retrieved old headers from storage)
        new_headers = nntp.getNews( name );
        for ( i = 0; i < new_headers.size(); i++ )
            articles.addElement( 
                new ArticleIndexEntry( (String)new_headers.elementAt( i ))
            );
        total_articles = articles.size();

        message = new String( "Retrieved " +
                              Integer.toString( total_articles ) +
                              " articles."                         );
        return ( message );
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------------
       /**
        *  Download the selected article from the server.
        *  
        ****/
    public String retrieve( int index ) {
        String header,
               number,
               response,
               tfile;
//        Article new_article;

//      header = (String)headers.elementAt( index );
//      StringTokenizer htok = new StringTokenizer( header, "\t");
//      try {
//          number = htok.nextToken();
//      } catch( NoSuchElementException NSEe ) { number = "0"; }

        number = ((ArticleIndexEntry)articles.elementAt( index )).number;
        if ( nntp.connected ) {
                            // download the article & get the return code 
            response = nntp.getArticle( number );
    		if ( NntpConnection.checkResponseCode( response,
                                                   NntpConnection.NNTP_ARTICLE_FOLLOWS ))
            {		        // find and save the article's storage location
                tfile = nntp.getTempFile();
                article_file = tfile;       // temporary kludge
// This is what we'll be doing eventually:
//                new_article = new Article( articles.elementAt( index ));
//                articles.elementAt( index ) = new_article;
    		}
		}     // else do nothing (for now - should eventually queue it somehow)
            else response = "499 Not online.";

        return ( response );
    } // -----------------------------------------------------------------


    // -------------------------------------------------------------------
	public void close( ) {
        // whatever
	} // -----------------------------------------------------------------

} // ========================[ End of NewsGroup ]=========================
