package njn;

public class ProgressMonitor extends Thread
{
    TextField display;
    NntpConnection nntp;
    String text;
    int total;

    // ----------------------------------------------------- constructor
    public ProgressMonitor( NntpConnection connection, 
                            TextField progress_display,
                            String message,
                            int expected_total          ) 
    {
        nntp = connection;
        display = progress_display;
        text = message;
        this.setPriority( Thread.MIN_PRIORITY );
    } // ---------------------------------------------------------------


    // ------------------------------------------------ run (overridden)
    public void run() {
        while ( nntp.progress > 0 ) {
            display.setText( text + " " +
                             Integer.toString( nntp.progress ) +
                             "% complete."                       );
            this.sleep( 250 );
        }
    } // ---------------------------------------------------------------
}
